browser.runtime.onMessage.addListener(msg => {
	switch (msg.action) {
	case "autofill":
		handleAutofill(msg);
	};
});

function handleAutofill(msg) {
	const form = findForm(msg.key);
	if (form === null) {
		// TODO: Bubble this up?
		return;
	}
	msg.key.map(pair => {
		if (pair.key === "proto" || pair.key === "host") {
			return;
		};
		const input = form.querySelector(`input[name="${pair.key}"]`);
		input.click();
		input.focus();
		input.value = pair.value;
		input.dispatchEvent(new KeyboardEvent('keydown', {bubbles: true}));
		input.dispatchEvent(new KeyboardEvent('keypress', {bubbles: true}));
		input.dispatchEvent(new KeyboardEvent('keyup', {bubbles: true}));
		input.dispatchEvent(new Event('input', {bubbles: true, cancellable: true}));
		input.dispatchEvent(new Event('change', {bubbles: true, cancellable: true}));
		input.blur();
	});
}

function findForm(key) {
	const forms = document.querySelectorAll("form");
	for (let i = 0; i < forms.length; i++) {
		const form = forms[i];
		let valid = true;
		key.map(pair => {
			if (pair.key === "proto" || pair.key === "host") {
				return;
			};
			if (pair.optional) {
				return;
			}
			const input = form.querySelector(`input[name="${pair.key}"]`);
			if (input === null) {
				valid = false;
			}
		});
		if (valid) {
			return form;
		}
	}
	return null;
}
