const conn = browser.runtime.connect();

conn.onMessage.addListener(msg => {
	switch (msg.action) {
	case "select-key":
		selectKey(msg.keys);
	}
});

function selectKey(keys) {
	document.getElementById("header").textContent = "Himitsu";
	const select = document.getElementById("select-key");
	select.classList.remove("hidden");
	const footer = document.getElementById("footer");
	footer.classList.remove("hidden");

	let selectedKey = null;
	if (keys.length === 1) {
		select.querySelector("p").remove();
		selectedKey = keys[0];
	}

	const keylist = document.getElementById("key-list");
	for (let i = 0; i < keys.length; i++) {
		const key = keys[i];
		const node = document.createElement("div");
		node.classList.add("himitsu-key");
		node.classList.add("panel-list-item");

		const container = document.createElement("div");
		container.classList.add("candidate");
		node.appendChild(container);

		key.map(pair => {
			if (pair.key === "proto") {
				return;
			}

			const span = document.createElement("span");
			span.classList.add("pair");
			if (pair.optional) {
				span.classList.add("optional");
			}
			if (pair.private) {
				span.classList.add("private");
			}

			const key = document.createElement("span");
			key.classList.add("key");
			key.textContent = pair.key;
			span.appendChild(key);

			const value = document.createElement("span");
			value.classList.add("value");
			if (pair.private) {
				value.textContent = "(hidden)";
			} else {
				value.textContent = pair.value;
			}
			span.appendChild(value);

			container.appendChild(span);
		});

		if (keys.length !== 1) {
			let item = keys[i];
			node.addEventListener("click", () => {
				Array
					.from(document.querySelectorAll(".himitsu-key"))
					.map(node => node.classList.remove("active"));
				node.classList.add("active");
				selectedKey = item;
			});
		} else {
			node.classList.add("no-hover");
		};

		keylist.appendChild(node);

		if (i + 1 < keys.length) {
			const sep = document.createElement("div");
			sep.classList.add("panel-section-separator");
			keylist.appendChild(sep);
		}
	};

	document.getElementById("cancel").addEventListener("click", () => {
		window.close();
	});

	document.getElementById("commit").addEventListener("click", () => {
		if (selectedKey === null) {
			return;
		}
		conn.postMessage({
			action: "autofill",
			key: selectedKey,
		});
		window.close();
	});
}

conn.postMessage({ action: "init-popup" });
